package com.its.op.service.its.rse;

import com.its.op.dao.repository.its.rse.TbRseOffrSectTrafHsRepository;
import com.its.op.dto.its.rse.TbRseOffrSectTrafHsDto;
import com.its.op.entity.its.rse.TbRseOffrSectTrafHs;
import com.its.op.entity.its.rse.TbRseOffrSectTrafHsKey;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbRseOffrSectTrafHsService {

    private final TbRseOffrSectTrafHsRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbRseOffrSectTrafHs requireOne(TbRseOffrSectTrafHsKey id) throws NoSuchElementException {
        Optional<TbRseOffrSectTrafHs> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return this.repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbRseOffrSectTrafHsDto> findAll() {
        List<TbRseOffrSectTrafHsDto> result = new ArrayList<>();
        List<TbRseOffrSectTrafHs> data = this.repo.findAll();
        for (TbRseOffrSectTrafHs entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbRseOffrSectTrafHsDto findById(TbRseOffrSectTrafHsKey id) {
        TbRseOffrSectTrafHs entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbRseOffrSectTrafHsDto updateById(TbRseOffrSectTrafHsKey id, TbRseOffrSectTrafHsDto.TbRseOffrSectTrafHsUpdReq req) {
        TbRseOffrSectTrafHs entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbRseOffrSectTrafHsDto> mergeInfoList(List<TbRseOffrSectTrafHsDto.TbRseOffrSectTrafHsUpdReq> reqList) {
        List<TbRseOffrSectTrafHsDto> result = new ArrayList<>();
        for (TbRseOffrSectTrafHsDto.TbRseOffrSectTrafHsUpdReq req : reqList) {
            TbRseOffrSectTrafHs obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbRseOffrSectTrafHsDto mergeInfo(TbRseOffrSectTrafHsDto.TbRseOffrSectTrafHsUpdReq req) {
        TbRseOffrSectTrafHs obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbRseOffrSectTrafHsDto deleteById(TbRseOffrSectTrafHsKey id) {
        TbRseOffrSectTrafHs entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbRseOffrSectTrafHsDto> deleteByIds(List<TbRseOffrSectTrafHsKey> ids) {
        List<TbRseOffrSectTrafHsDto> result = new ArrayList<>();
        for (TbRseOffrSectTrafHsKey id : ids) {
            Optional<TbRseOffrSectTrafHs> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
